
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Graphics Vision Demo Program                    }
{                                                       }
{       Copyright (c) 1994,95 by Solar Designer         }
{                                                       }
{*******************************************************}

uses
   GraphDrv, GModes, GRect, KeyMouse, Events, MousePtr,
   DrawLat;

var
   R               :TGRect;
   E               :TEvent;

procedure ShowMsg(const Msg            :String);
begin
   Bar(0, 0, GetMaxX, 7, DarkGray);
   SetTextJustify(CenterText, TopText);
   OutTextXY(DriverPtr^.SizeX shr 1, 0, Msg, White);
end;

procedure WaitEvent;
begin
   repeat
      GetKeyEvent(E);
      if E.What=evNothing then GetMouseEvent(E);
   until (E.What=evKeyDown) or (E.What=evMouseDown);
end;

begin
   if LoadDriver('DRIVERS\VESA256.DRV')<>gdOk then Halt;
   InitDriver(gm640x400x256);
   if SetGraphMode<>gdOk then Halt;

   UseMouse:=True;
   InitMousePtr;
   InitEvents;

   R.Assign(0, 8, GetMaxX, GetMaxY);
   SetMouseRange(R);
   R.GetCenter(R.A);
   SetMousePos(R.A);

   R.Assign(100, 100, 150, 150);
   Rectangle(R.A.X, R.A.Y, R.B.X, R.B.Y, 15);
   HideMouseRect(R);

   R.Assign(200, 50, 250, 80);
   Rectangle(R.A.X, R.A.Y, R.B.X, R.B.Y, 15);
   HideMouseRect(R);

   Rectangle(MouseEA.A.X, MouseEA.A.Y, MouseEA.B.X, MouseEA.B.Y, 12);

   ShowMsg('The mouse pointer should be hidden while inside the red rectangle');
   WaitEvent;

   ShowMouseRect; ShowMouseRect;
   Rectangle(MouseEA.A.X, MouseEA.A.Y, MouseEA.B.X, MouseEA.B.Y, 12);

   ShowMsg('Now it should be visible everywhere');
   WaitEvent;

   ShowMsg('Note that the mouse pointer blinks only when drawing a bar under it');
   repeat
      R.Assign(Random(DriverPtr^.SizeX), Random(DriverPtr^.SizeY-8)+8,
         Random(DriverPtr^.SizeX), Random(DriverPtr^.SizeY-8)+8);
      HideMouseRect(R);
      Bar(R.A.X, R.A.Y, R.B.X, R.B.Y, Random(DriverPtr^.MaxColor+1));
      ShowMouseRect;
      GetKeyEvent(E);
      if E.What=evNothing then GetMouseEvent(E);
   until (E.What=evKeyDown) or (E.What=evMouseDown);

   DoneEvents;
   DoneMousePtr;

   CloseGraph;
end.
